%ext ck6
%version 1.4

#########
# Files #
#########

#New Graphics
%egahead EGAHEAD.CK6
%patchfile $372EE EGADICT.CK6

#New Levels
%maphead maphead.ck6

#New Tracks and Sounds
%patchfile $20C50 AUDIOHED.CK6  #Audio header
%patchfile $36EEE AUDIODCT.CK6  #Audio dictionary

#New Scrolling Story
%patchfile $1ED50 "STORY.CK6"

#New Start Screen
%patchfile $1FCA7 CK6LOAD.BIN

#New Tileinfo
%patchfile $25212 keen14.tli

##################
# Disable stuff  #
##################

##### Cheats #####

#Don't need debug mode to use F10 cheats
%patch $784B $90 $90

#Disable the B A T cheat (Frees $7605 - $7679)
%patch $782D $EB $17

#Disable F9 cheat - Keen 6 (Frees $77D0 -$7827)
%patch $77CF $EB $5C

#Disable END cheat code
%patch $8F10 $EB $19

#Disable F10-I
%patch $72EE $EB

#Disable F10-Y (Free $75D1-75E2, $7012-$717A)
%patch $75CF $EB $12

#Disable Keen 6 F10-D (Frees $7238-$726D, $6270-$6401, $14E6A-$14EB1)
%patch $7236 $EB $35

#Disable A 2 Enter keys
%patch $8092 $EB

##### Sounds #####

#Don't play Keen jumping hits head sound
%patch $C5AB $EB $0A 

#Don't play Keen pogoing hits head sound
%patch $C905 $EB $0A 

#Patch by K1n9_Duk3
#Sounds produced by those tiles:
%patch $1F684
	$FFFFW	# Sound for first tile (stomp sound)
	$FFFFW	# Sound for second tile (flame sound)

##### Other #####

#Don't draw Goplat Bips in Keen 6
%patch $10738 $5E $5D $CB

#Don't draw
%patch $7C48 $90 $90 $90 $90 $90 #Items text
%patch $7C63 $90 $90 $90 $90 $90 #Background rectangle

%patch $7C7E $90 $90 $90 $90 $90 #Sandwich if got
%patch $7C94 $90 $90 $90 $90 $90 #Sandwich not got
%patch $7C6B $EB $2F		 #Sandwich at all

%patch $7CAF $90 $90 $90 $90 $90 #Rope+hook if got
%patch $7CC5 $90 $90 $90 $90 $90 #Rope+hook not got
%patch $7C9C $EB $2F		 #Rope+hook at all

%patch $7CE0 $90 $90 $90 $90 $90 #Rocket card if got
%patch $7CF6 $90 $90 $90 $90 $90 #Rocket card not got
%patch $7CCD $EB $2F		 #Rocket card at all

#Skip creature question 1(Frees $1CC7F - $1CF38)
%patch $1CC7B $B8 $0001W $CB

#Skip creature question 2(Frees $1CC93 - $1CF38)
%patch $1CC88 $90 $90

#Disable all demos -Keen 6
%patch $570A $CB 

######################
# Fixing Keen 6 bugs #
######################

#Fix impossible bullet bug
%patch $BF24 $27
%patch $BF38 $EB $0F

#Molly doesn't clip through doors
%patch $1009B $FEF0W

#################
# Changed stuff #
#################

#Change "RETURN TO DEMO" to "STORY"
%patch $35613 "STORY" $00

#Keen starts game in the BWB
%patch $5A8F $75A4W $0011W

#Keen always pogoes at medium/hard height
%patch $B760  $EB    

#######################
# Colors and palettes #
#######################

#Terminator text color map:
%patch $30E7C $00 $02 $02 $12 $03 $03 $03 $03     #Dark colors
              $03 $03 $03 $03 $13 $13 $13 $13 $00 #Light colors (and border color)

#Zoom out color map:
%patch $30E8D $00 $02 $02 $12 $03 $03 $03 $03     #Dark colors
              $03 $03 $03 $03 $13 $13 $13 $13 $00 #Light colors (and border color)

#Story background palette:
%patch $30E62 $00 $01 $18 $19 $04 $1C $06 $1F     #Dark colors
              $1F $1F $1F $1F $1F $1F $1F $1F $00 #Light colors (and border color)

################
# 20000 points #
################

#Ceilick is 20'000 points item
%patch $124AC $55 $8B $EC $33 $C0 $50 $9A $069A1E25RL     $83 $C4 $02 $8B $1E
              $66 $A9 $C7 $07 $0010W  $C7 $47 $02 $0001W  $C7 $47 $20 $0001W
              $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $05
              $FFF0W  $89 $47 $0C $8B $1E $66 $A9 $C7 $47 $0E $FFFFW  $8B $1E
              $66 $A9 $C7 $47 $10 $0001W  $C7 $47 $06 $0000W  $B8 $31BEW  $50
              $53 $9A $08F41219RL     $83 $C4 $04 $5D $CB

#20'000 point item collision
%patch $1255C $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $1D #Check for Keen
              $B8 $4E20W  $50 $9A $069A1F06RL $83 $C4 $02 $C7 $44 $1C $3434W  #Change action to Ceilick got, give 20000
              $B8 $0008W  $50 $9A $183B09F1RL $83 $C4 $02 $5F $5E $5D $CB     #Play sound

#Ceilick item sit action
%patch $33EEE $00F8W $00F8W $0002W $0000W $0000W $000AW $0000W $0000W
              $0EFC0E21RL   $11CF086CRL   $08F4180ARL   $31BEW

#20'000 point got action =$2550W
%patch $34164 $00FDW $00FDW $0001W $0000W $0000W $0048W $0000W $FFF8W
              $00000000L    $00000000L    $08F4180ARL   $0000W

#Ceilick initiation code
%patch $E7FA $83 $3E $75A8W  $03 $7D $03 $E9 $00C3W  $83 $3E $75A8W  $02 $7D
             $03 $E9 $00B9W  $57 $56 $9A $11CF07BCRL     $83 $C4 $04 $C7 $06
             $CD3BW  $0001W  $E9 $00A6W

#20K spawning code
%patch $124AC $55 $8B $EC $33 $C0 $50 $9A $069A1E25RL     $83 $C4 $02 $8B $1E
              $66 $A9 $C7 $07 $0010W  $C7 $47 $02 $0001W  $C7 $47 $20 $0001W
              $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B $46 $08 $D3 $E0 $05
              $FFF0W  $89 $47 $0C $8B $1E $66 $A9 $C7 $47 $0E $FFFFW  $8B $1E
              $66 $A9 $C7 $47 $10 $0001W  $C7 $47 $06 $0000W  $B8 $31FAW  $50
              $53 $9A $08F41219RL     $83 $C4 $04 $5D $CB

#20K actions =$2514W
%patch $33F0C $00F8W $00F8W $0000W $0000W $0000W $000AW $0000W $0000W
              $00000000L    $11CF086CRL   $08F4180ARL   $31DCW
%patch $33F2A $00F9W $00F9W $0000W $0000W $0000W $000AW $0000W $0000W
              $00000000L    $11CF086CRL   $08F4180ARL   $31FAW

##################
# Conveyor Belts #
##################

#Conveyor belt speeds - standing
%patch $C3F5 $BA $0010W  $F7 $EA $90
%patch $C41E     $FFF0W

#Conveyor belt speeds - walking
%patch $C4B3 $BA $0010W  $F7 $EA $90
%patch $C4D7     $FFF0W

#########
# Score #
#########

#Reset Keen's score when he dies
%patch $1CC93 $55 $8B $EC $56 $8B $76 $06 $A1 $7584W  $A3 $7588W
                  $A1 $7586W  $A3 $758AW  $5E $5D $CB

#Store Keen's score on level load
%patch $67D9 $A1 $7588W  $A3 $7584W  $A1 $758AW  $A3 $7586W  $EB $3D

#Call reset Keen's score on death
%patch $64F7 $9A $1A502793RL     $BF $0001W  $EB $06

#################
# Chaos Tempest #
#################

#Don't show Keen's bitmap in window - Sandwich window
%patch $EE35  $EB $0A
%patch $EE51  $EB $19

#Sandwich Text
%patch $325B6 "You've found the  "
%patch $325C9 "Light Cloud!    "
%patch $325DA "Fantastic! "

#############
# Amugkidus #
#############

#K1n9_Duk3 addition: Grappling hook continues level = $125A1641RL
%patch $32A68 $125A1641RL
%patch $13BE1
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$8B $5E $08		#	mov	bx, [bp+8]
	$83 $3F $02		#	cmp	[bx], keenobj
	$75 $13			#	jnz	done
	$9A $0E420A8Arl		#	call	AmugkidusDialog
	$FF $76 $06		#	push	[bp+6]
	$9A $069A1E9Frl		#	call	RemoveObj
	$58			#	pop	ax
	$9A $16080E88rl		#	call	RF_ForceRefresh
				#done:
	$5D			#	pop	bp
	$CB			#	retf
	

#Amugkidus text
%patch $325E7 "You, fool! I'm" $0A
              "not the sorcerer" $0A
              "you were searching" $0A 
              "for, stupid boy!" $0A $00

############################
# Bloog = Bird Transporter #				
############################

#Bloog harmless
%patch $108CC $EB

#Bloog sprite type: Push Keen
%patch $1083E $06

#New star spec for Bloogs
%patch $A9A0 $C7 $46 $FE $0080W  $BF $FFC0W  $EB $02

#Change Bloog cache by 1
%patch $3242C $0155W #Bloog cache start
%patch $3247C $015DW #Bloog cache end

#Move stunned Bloog animations
%patch $32C8E $0155W $0155W

#Bloog is rideable when stunned, too
%patch $32CA2 $0EFC002DRL 

#####################
# Gik = Mini Rocket #				
#####################

#Gik always kills Keen
%patch $33348 $08F417EERL #Walking
%patch $33366 $08F417EERL #Walking
%patch $33384 $08F417EERL #Walking
%patch $333A2 $08F417EERL #Jumping
%patch $333C0 $08F417EERL #Sliding
%patch $333DE $08F417EERL #Sliding
%patch $333FC $08F417EERL #Recovering

############################
# Blooguard = Electro Boss #
############################

#Blooguard's strength (45)
%patch $1094D $002DW

#Patch by K1n9_Duk3
# StunAndSpawn routine (replaces some unused code in the input manager)
# Call this routine with
# - bx set to the desired item number (0 = red key, ... 10 = 1UP, 11 = ammo)
# - ax set to the offset of the desired stunned state
# - si set to the enemy object
# - di set to the shot object

%patch $14800
	$53			#	push	bx
	$50			#	push	ax
	$57			#	push	di
	$56			#	push	si
	$9A $08F41722rl		#	call	StunContact
	$83 $C4 $06		#	add	sp, 6
	$33 $C0			#	xor	ax, ax
	$50			#	push	ax
	$9A $069A1E25rl		#	call	GetNewObj
	$58			#	pop	ax
	$5B			#	pop	bx
	$57			#	push	di
	$8B $3E $A966w		#	mov	di, new
	$C7 $45 $06 $0001w	#	mov	di+objtype.needtoclip, 1
	$C7 $45 $20 $0002w	#	mov	di+objtype.priority, 2
	$C7 $05 $0005w		#	mov	di+objtype.obclass, bonusobj
	$8B $44 $0A		#	mov	ax, si+objtype.x
	$89 $45 $0A		#	mov	di+objtype.x, ax
	$8B $44 $0C		#	mov	ax, si+objtype.y
	$89 $45 $0C		#	mov	di+objtype.y, ax
	$C7 $45 $10 $FFFFw	#	mov	di+objtype.ydir, -1
	$C7 $45 $18 $FFD8w	#	mov	di+objtype.yspeed, -40
	$89 $5D $3E		#	mov	di+objtype.temp1, bx
	$D1 $E3			#	shl	bx, 1
	$8B $87 $1A78w		#	mov	ax, bonusshape[bx]
	$89 $45 $1E		#	mov	di+objtype.shapenum, ax
	$89 $45 $40		#	mov	di+objtype.temp2, ax
	$40			#	inc	ax
	$40			#	inc	ax
	$89 $45 $42		#	mov	di+objtype.temp3, ax
	$B8 $19A6w		#	mov	ax, offset bonusfall1
	$50			#	push	ax
	$57			#	push	di
	$9A $08F41219rl		#	call	NewState
	$58			#	pop	ax
	$58			#	pop	ax
	$B8 $0005w		#	mov	ax, SND_DROPKEY
	$50			#	push	ax
	$9A $183B09F1rl		#	call	SD_PlaySound
	$58			#	pop	ax
	$5F			#	pop	di
	$CB			#	retf

# Stunning a Blooguard spawns a red key
#
# Note: The level must have at least one keygem (of any color) or a blooglet
# that spawns a key (of any color) to make sure the sprites for the yellow key are
# loaded. If the sprites are not loaded, the game will quit with an
# RF_PlaceSprite error message when the Blooguard is stunned.

%patch $10A19
	$BB $0000w		#	mov	bx, 0
	$9A $141306D0rl		#	call	StunAndSpawn
	$90 $90 $90		#	nop nop nop

#Clubs any time, no matter where Keen is
%patch $109B5 $90 $90

#Clubbing behavior
%patch $32D52 $0EFC1A09RL
%patch $32D70 $00000000L

#Clubbing collision
%patch $32D38 $00000000L #Kill Keen
%patch $32D56 $00000000L #Kill Keen
%patch $32D74 $00000000L #Kill Keen
%patch $32D92 $08F417EERL #Kill Keen

#Clubbing speeds
%patch $32D2E $0009W        
%patch $32D4C $001EW        
%patch $32D6A $0009W       

##################
# Orbatrix = ??? #
##################

#Orbatrix float behavior
%patch $1154E $55 $8B $EC $56 $57 $8B $76 $06 $9A $1CF30034RL     $3D $0040W
              $7D $15 $9A $1CF30034RL     $3D $0080W  $7D $05 $B8 $0001W
              $EB $03 $B8 $FFFFW  $89 $44 $0E $5F $5E $5D $CB

#Speed up the Orbatrix
%patch $33522 $0020W $0000W
%patch $33540 $0020W $0000W

#1 float loop
%patch $33532 $27E6W

#When shot: bounce
%patch $115BB $2930W

#Shrink Cache
%patch $3249C $014DW

#Animations
%patch $33516 $0149W $0149W #Floating
%patch $33660 $014AW $014DW #Bouncing
%patch $3367E $014BW $014CW 
%patch $3369C $014CW $014BW  
%patch $336BA $014DW $014AW

#Never stop bouncing
%patch $11683 $EB

#########################
# Blorb = Electrosphere #
#########################

#Blorb floating h\v speeds
%patch $33EA0 $0010W $0010W
%patch $33EBE $0010W $0010W
%patch $33EDC $0010W $0010W

#Don't play Blorb sounds
%patch $12437 $EB $0A #Don't play Blorb hit floors sound
%patch $12450 $EB $0A #Don't play Blorb hit ceilings sound
%patch $12467 $EB $0A #Don't play Blorb hit right walls sound
%patch $12480 $EB $0A #Don't play Blorb hit left walls sound

############################
# Nospike = Guardian Robot #
############################

#Nospike's strength
%patch $10D35 $0002W

##############################
# Babobba = Acid Roborhombus #
##############################

#Babobba shoots after every jump
%patch $1218B $0002W

#Babobba doesn't nap
%patch $1216A $EB $18

#Babobba's shot is now M-C Defenser's shot
%patch $121E9 $2DFEW

#Cache M-C Defenser
%patch $E8AE $C6 $06 $CD2Bw $01 $E9 $FDE9w

##########################
# Blue Blooglet = Cybird #
##########################

#Blooglet collision
%patch $10BED $55 $8B $EC $56 $8B $76 $08 $83 $3C $02 $75 $08 $9A $0AA213CARL
                 $5E $5D $CB $83 $3C $03 $75 $10 $B8 $222EW  $50 $56 $FF $76
             $06 $9A $08F41722RL     $83 $C4 $06 $5E $5D $CB

##########################
# Bipship = Attack Drone #
##########################

#Bipship is lethal to Keen and shootable
%patch $11ABD $55 $8B $EC $56 $8B $76 $08 $83 $3C $03 $75 $0F $56 $9A $0CA60EC2RL
                      $83 $C4 $02 $B8 $2B10W  $E9 $F99FW  $83 $3C $02 $75 $03
              $E9 $07D3W  $5E $5D $CB

#Crashed Bipship doesn't spawn a Bip
%patch $11A5F $5E $5D $CB	

#K1n9_Duk3 addition: Bipship doesn't cache Bip sprites anymore
%patch $E7A0 $A3 $CD35w $E9 $0121w

#Bipship kills Keen also when stunned
%patch $33890 $08F417EERL 

#################
# Tempest Cloud #
#################

# New addition by K1n9_Duk3. Taking over the states and sprites of the walking
# Bip. Overwrites parts of the Keen Dreams style loading screen code (already
# partially overwritten by the "Amugkidus" patch above).

%patch $13C01
#SpawnCloud
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$33 $C0			#	xor	ax, ax
	$50			#	push	ax
	$9A $069A1E25rl		#	call	GetNewObj
	$5B			#	pop	bx
	$8B $1E $A966w		#	mov	bx, new
	$8A $46 $06		#	mov	al, [bp+6]
	$88 $47 $0B		#	mov	[bx+objtype.x+1], al
	$8A $46 $08		#	mov	al, [bp+8]
	$88 $47 $0D		#	mov	[bx+objtype.y+1], al
	$88 $47 $41		#	mov	[bx+objtype.temp2+1], al
	$C6 $07 $2A		#	mov	[bx+objtype.obclass], 42
	$B0 $02			#	mov	al, 2
	$88 $47 $3E		#	mov	[bx+objtype.temp1], al
	$88 $47 $20		#	mov	[bx+objtype.priority], al
	$B0 $01			#	mov	al, 1
	$88 $47 $0E		#	mov	[bx+objtype.xdir], al
	$88 $47 $10		#	mov	[bx+objtype.ydir], al
	$C7 $47 $1E $01A0w	#	mov	[bx+objtype.shapenum], 416
	$B8 $29C6w		#	mov	ax, offset s_cloud
	$50			#	push	ax
	$53			#	push	bx
	$9A $08F41219rl		#	call	NewState
	$58			#	pop	ax
	$58			#	pop	ax
	$5D			#	pop	bp
	$CB			#	retf


#CloudThink:
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$56			#	push	si
	$8B $76 $06		#	mov	si, [bp+6]
	$9A $1CF30034rl		#	call	US_RndT
	$3B $06 $A6DAw		#	cmp	ax, tics
	$73 $14			#	jnb	l2
	$8B $1E $A964w		#	mov	bx, player
	$8B $44 $0A		#	mov	ax, [si+objtype.x]
	$3B $47 $0A		#	cmp	ax, [bx+objtype.x]
	$B8 $0001w		#	mov	ax, 1
	$76 $02			#	jbe	l1
	$F7 $D8			#	neg	ax
				#l1:
	$89 $44 $0E		#	mov	[si+objtype.xdir], ax
				#l2:
	$B8 $000aw		#	mov	ax, 32
	$50			#	push	ax
	$FF $74 $0E		#	push	[si+objtype.xdir]
	$56			#	push	si
	$9A $08F4148Brl		#	call	AccelerateX
	$83 $C4 $06		#	add	sp, 6
	$8B $1E $A964w		#	mov	bx, player
	$8B $47 $28		#	mov	ax, [bx+objtype.bottom]
	$3B $44 $28		#	cmp	ax, [si+objtype.bottom]
	$72 $25			#	jb	done
	$8B $47 $24		#	mov	ax, [bx+objtype.top]
	$2B $44 $28		#	sub	ax, [si+objtype.bottom]
	$3D $0800w		#	cmp	ax, 400h
	$7F $1A			#	jg	done
	$8B $44 $22		#	mov	ax, [si+objtype.left]
	$3B $47 $26		#	cmp	ax, [bx+objtype.right]
	$73 $12			#	jnb	done
	$8B $44 $26		#	mov	ax, [si+objtype.right]
	$3B $47 $22		#	cmp	ax, [bx+objtype.left]
	$76 $0A			#	jbe	done
	$C7 $44 $1C $29E4w	#	mov	[si+objtype.state], offset s_cloudattack
	$C7 $44 $42 $0003w	#	mov	[si+objtype.temp3], 3
				#done:
	$A1 $A6DAw		#	mov	ax, tics
	$29 $44 $1A		#	sub	[si+ticcount], ax
	$7F $08			#	jg	l3
	$83 $44 $1A $14		#	add	[si+ticcount], 20
	$80 $74 $1E $01		#	xor	[si+objtype.shapenum], 1
				#l3:
	$80 $64 $1E $F1		#	and	[si+objtype.shapenum], 0F1h
	$5E			#	pop	si
	$5D			#	pop	bp
	$CB			#	retf

#CloudContact:
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$8B $5E $08		#	mov	bx, [bp+8]
	$83 $3F $03		#	cmp	[bx], shotobj
	$75 $1E			#	jnz	done
	$53			#	push	bx
	$9A $0CA60EC2rl		#	call	ExplodeShot
	$58			#	pop	ax
	$8B $5E $06		#	mov	bx, [bp+6]
	$33 $C0			#	xor	ax, ax
	$89 $47 $18		#	mov	[bx+objtype.yspeed], ax
	$89 $47 $16		#	mov	[bx+objtype.xspeed], ax
	$B8 $2A20w		#	mov	ax, offset s_cloudfall
	$50			#	push	ax
	$53			#	push	bx
	$9A $08F41297rl		#	call	ChangeState
	$58			#	pop	ax
	$58			#	pop	ax
				#done:
	$5D			#	pop	bp
	$CB			#	retf

%patch $13CEF
#CloudRise:
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$8B $5E $06		#	mov	bx, [bp+6]
	$8B $47 $40		#	mov	ax, [bx+objtype.temp2]
	$2B $47 $0C		#	sub	ax, [bx+objtype.y]
	$7C $0D			#	jl	done
	$A3 $CA87w		#	mov	tmp_ymove, ax
	$C7 $47 $1C $2A02w	#	mov	[bx+objtype.state], offset s_cloudafter
	$C7 $47 $18 $0000w	#	mov	[bx+objtype.yspeed], 0
				#done:
	$5D			#	pop	bp
	$CB			#	retf

%patch $13D0C
#CloudAttack:
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$56			#	push	si
	$8B $76 $06		#	mov	si, [bp+6]
	$B8 $000aw		#	mov	ax, 20h
	$50			#	push	ax
	$FF $74 $0E		#	push	[si+objtype.xdir]
	$56			#	push	si
	$9A $08F4148Brl		#	call	AccelerateX
	$83 $C4 $06		#	add	sp, 6
	$A1 $A6DAw		#	mov	ax, tics
	$01 $47 $1A		#	add	[si+objtype.ticcount], ax
	$83 $7C $1A $14		#	cmp	[si+objtype.ticcount], 20
	$72 $16			#	jb	done
	$56			#	push	si
	$9A $10CC0717rl		#	call	TurretThink
	$58			#	pop	ax
	$33 $C0			#	xor	ax, ax
	$89 $44 $1A		#	mov	[si+objtype.ticcount], ax
	$FF $4C $42		#	dec	[si+objtype.temp3]
	$75 $05			#	jnz	done
	$C7 $44 $1C $2A02w	#	mov	[si+objtype.state], offset s_cloudafter
				#done:
	$5E			#	pop	si
	$5D			#	pop	bp
	$CB			#	retf

#CloudReact:
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$8B $5E $06		#	mov	bx, [bp+6]
	$8B $47 $38		#	mov	ax, [bx+objtype.hiteast]
	$0B $47 $3C		#	or	ax, [bx+objtype.hitwest]
	$74 $08			#	jz	draw
	$F7 $5F $0E		#	neg	[bx+objtype.xdir]
	$C7 $47 $16 $0000w	#	mov	[bx+objtype.xspeed], 0
				#draw:
	$53			#	push	bx
	$9A $08F4180Arl		#	call	DrawReact
	$58			#	pop	ax
	$5D			#	pop	bp
	$CB			#	retf

#states:

%patch $336F6
#floating:
	$0000w $0000w $0002w $0000w $0000w $0000w $0000w $0000w
	$125A16A6rl   $125A1724rl   $125A17A8rl   $0000w		#CloudThink, CloudContact, CloudReact, NULL
#attacking:
	$01A2w $01A2w $0002w $0000w $0000w $0000w $0000w $0000w
	$125A176Crl   $125A1724rl   $125A17A8rl   $0000w		#CloudAttack, CloudContact, CloudReact, NULL
#after attack:
	$01A2w $01A2w $0004w $0000w $0000w $0046w $0000w $0000w
	$08F4179Drl   $125A1724rl   $125A17A8rl   $29C6w		#VelocityThink, CloudContact, CloudReact, s_cloud
#falling:
	$01A3w $01A3w $0003w $0000w $0000w $015Ew $0000w $0000w
	$08F41323rl   $00000000l    $08F4180Arl   $2A3Ew		#DoGravity4, NULL, DrawReact, s_cloudrise
#rising:
	$01A3w $01A3w $0004w $0000w $0000w $7FFFw $0000w $FFF0w
	$125A174Frl   $00000000l    $08F4180Arl   $2A3Ew		#CloudRise, NULL, DrawReact, s_cloudrise

#merge Keen spawns:
%patch $E4B5
	$EB $D4

#add cloud spawning code:
%patch $E4B7
	$83 $3E $75A8w $03 $7C $16		#check hard difficulty
	$83 $3E $75A8w $02 $7C $0F		#check normal difficulty
	$57 $56 $9A $125A1661rl $58 $58		#SpawnCloud(x, y);
	$C7 $06 $CD31w $0001w			#lunmpneeded[CLOUDLUMP] = true;
	$E9 $0244w

#InfoPlane icons $15-$17 spawn the Tempest Cloud - easy, normal, hard:
%patch $E97A $00A5w $009Ew $0097w

#cloud cache is only 416-419
%patch $32444 $01A0w
%patch $32494 $01A3w

#######################
# Flect = Mirrorrobot #
#######################

#Flect kills Keen instead of pushing him
%patch $11C08 $9A $0AA213CARL $5F $5E $5D $CB

#Stunned Flect recovers, no stun stars
%patch $3398A $0148W $0148W $0000W $0000W $0001W $0080W $0000W $0000W
              $00000000L    $00000000L   $10CC0F96RL   $2BC4W

#######################
# Fleex = Spiderytryx #
#######################

#Fleex's strength
%patch $11D6F $0003W

#Fleex just chases Keen
%patch $11D82 $EB

###################
# Levels          #
###################

#Where music list is read from:
%patch $8AA7 $030EW  #$3103E
%patch $8A88 $14     #Total number of level entries

#Song values:
#00 = 3 06 The Nightmare XG  01 = World of Illusion - Magician's Domain
#02 = Bach - Invention 13    03 = Too Silent
#04 = Faster                 05 = You have to Change!
#06 = Midnight on Montgomery 07 = Metal
#08 = Mamba Snake

#This is the music played in each level:
#             VALUE   LEVEL                           MUSIC PLAYED                                    LEVEL No
%patch $3103E $0000W  #Pterygon VIII                  (3 06 The Nightmare XG)                            0
              $0004W  #Bird Swamp                     (Faster)                                           1
              $0007W  #Lake of Dangers                (Metal)                                            2
              $0003W  #Mountain Mine                  (Too Silent)                                       3
              $0007W  #Green Wood                     (Metal)                                            4
              $0003W  #Silent Forest                  (Too Silent)                                       5
              $0001W  #Tempest Islands                (World of Illusion - Magician's Domain)            6
              $0003W  #Ancient Hill                   (Too Silent)                                       7
              $0004W  #Great Cliff                    (Faster)                                           8
              $0007W  #Robotic Station                (Metal)                                            9
              $0005W  #Acid Regulation Center         (You have to Change!)                              10
              $0005W  #EleKtro Company                (You have to Change!)                              11
              $0008W  #EleKtro Company Ship           (Mamba Snake)                                      12
              $0008W  #Robotic Mines                  (Mamba Snake)                                      13
              $0004W  #Bridge Station                 (Faster)                                           14
              $0008W  #Robots'Secret Base             (Mamba Snake)                                      15
              $0002W  #Magic Hills                    (Bach - Invention 13)                              16
              $0006W  #Bean-with-Bacon Megarocket     (Midnight on Montgomery)                           17
              $0006W  #High Scores                    (Midnight on Montgomery)                           18

#Ending Sequence music: World of Illusion - Magician's Domain
%patch $E33C $0006W 

#Scrolling Story music: You have to Change!
%patch $563F $000BW 

#Status Window
%patch $312F1 "KEYS" $00 
              "AMMO" $00 
              "KEENS" $00 
              "POTIONS" $00

%level.name 0 Pterygon VIII
%level.entry 0 Keen searches\n Pterygon VIII
%patch $30F95 "Exit to Pterygon VIII" $00 

%level.name 1 Bird Swamp
%level.entry 1 Keen jumps in\n the Bird Swamp

%level.name 2 Lake of Dangers 
%level.entry 2 Keen escapes from\n the Lake of Dangers

%level.name 3 Mountain Mine
%level.entry 3 Keen enters into\n the Mountain Mine

%level.name 4 Green Wood
%level.entry 4 Keen finds the\n Green Wood

%level.name 5 Silent Forest
%level.entry 5 Keen travels through\n the Silent Forest

%level.name 6 Tempest Islands
%level.entry 6 Keen affronts\n Tempest Islands

%level.name 7 Ancient Hill
%level.entry 7 Keen explores the\n Ancient Hill

%level.name 8 Great Cliff
%level.entry 8 Keen falls into\n the Great Cliff

%level.name 9 Robotic Station
%level.entry 9 Keen crosses the\n Robotic Station

%level.name 10 Acid R. Center
%level.entry 10 Keen attacks the\n Acid\n Regulation Center

%level.name 11 EleKtro Company
%level.entry 11 Keen disables the\n EleKtro Company

%level.name 12 EleKtro Company Ship
%level.entry 12 Keen investigates on\n the EleKtro Company\n Ship

%level.name 13 Robotic Mines
%level.entry 13 Keen infiltrates\n the Robotic Mines

%level.name 14 Bridge Station
%level.entry 14 Keen anxiously\n actives the\n Bridge Station

%level.name 15 Secret Base
%level.entry 15 Keen discovers\n Robots'\n Secret Base

%level.name 16 Magic Hills
%level.entry 16 Keen has finally\n come around\n Magic Hills

%level.name 17 BWB Megarocket Pond
%level.entry 17 Keen starts his trip\n around the BWB Pond

#Names:
%patch $34AF4 "DarkAle" $00
%patch $34B34 "Awesome-Keener" $00
%patch $34B74 "K1n9_Duk3" $00
%patch $34BB4 "Ceilick" $00
%patch $34BF4 "55Aavenue" $00
%patch $34C34 "XkyRauh" $00
%patch $34C74 "Syllypryde" $00
%patch $34CB4 "Bird VIII" $00

################################################################################
# Customized Screen Update Code For KEEN6 v1.4 (EGA)
# Copyright (c) 2019 K1n9_Duk3
#
# This software is provided 'as-is', without any express or implied warranty. In
# no event will the authors be held liable for any damages arising from the use
# of this software.
#
# Permission is granted to anyone to use this software for any purpose, including
# commercial applications, and to alter it and redistribute it freely, subject to
# the following restrictions:
#
# 1. The origin of this software must not be misrepresented; you must not claim
#    that you wrote the original software. If you use this software in a product,
#    an acknowledgment in the product documentation would be appreciated but is
#    not required.
#
# 2. Altered source versions must be plainly marked as such, and must not be
#    misrepresented as being the original software.
#
# 3. This notice may not be removed or altered from any source distribution.
################################################################################

#replace the v1.4 delay code with my custom VW_SetScreen code
#(my VW_SetScreen is bigger than the one in v1.4)
%patch $1E713
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$BA $03DAw		#	mov	dx, 3DAh
	$FA			#	cli
				#@l1:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$74 $FB			#	jz	@l1
				#@l2:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$75 $FB			#	jnz	@l2
	$8B $4E $06		#	mov	cx, [bp+arg_start]
	$BA $03D4w		#	mov	dx, 3D4h
	$B0 $0C			#	mov	al, 0Ch
	$EE			#	out	dx, al
	$42			#	inc	dx
	$8A $C5			#	mov	al, ch
	$EE			#	out	dx, al
	$4A			#	dec	dx
	$B0 $0D			#	mov	al, 0Dh
	$EE			#	out	dx, al
	$8A $C1			#	mov	al, cl
	$42			#	inc	dx
	$EE			#	out	dx, al
	$F7 $06 $754Cw $0001w	#	test	fixjerky, 1
	$74 $03			#	jz	@l3
	$E8 $0053w		#	call	WaitVBL
				#@l3:
	$F7 $06 $761Aw $0001w	#	test	nopan, 1
	$75 $0C			#	jnz	l4
	$BA $03C0w		#	mov	dx, 3C0h
	$B0 $33			#	mov	al, 33h
	$EE			#	out	dx, al
	$EB $00			#	jmp	$
	$8A $46 $08		#	mov	al, [bp+arg_pan]
	$EE			#	out	dx, al
				#@l4:
	$F7 $06 $754Cw $0001w	#	test	fixjerky, 1
	$75 $03			#	jnz	@l5
	$E8 $0034w		#	call	WaitVBL
				#@l5:
	$FB			#	sti
	$5D			#	pop	bp
	$CB			#	retf

#replace the start of VW_SetScreen with a jump into my new code (see above):
%patch $1E794
	$E9 $FF7Cw

#and overwrite the rest of the old VW_SetScreen code with my WaitVBL code:
	$8B $1E $A6CBw		#	mov	bx, word ptr TimeCount
	$BA $03DAw		#	mov	dx, 3DAh
				#@wait:	
	$FB			#	sti
	$EB $00			#	jmp	short $
	$FA			#	cli
	$EC			#	in	al, dx
	$A8 $08			#	test	al, 8
	$75 $0A			#	jnz	@done
	$A1 $A6CBw		#	mov	ax, word ptr TimeCount
	$2B $C3			#	sub	ax, bx
	$3D $0001w		#	cmp	ax, 1
	$76 $ED			#	jbe	@wait
				#@done:
	$C3			#	retn

################################################################################
# End of Customized Screen Update Code
################################################################################

########################################################
# Free Tile And Sprite Graphics Before Loading A Level #
########################################################

#Free sprites and tiles before loading a level
%patch $5FAD
	$74 $0A			#	jz	no_demo
	$C7 $06 $6F6Cw $0002w	#	mov	gamestate_difficulty, 2
	$33 $C0			#	xor	ax, ax
	$EB $03			#	jmp	init_rndt
				#no_demo:
	$B8 $0001w		#	mov	ax, 1
				#init_rndt:
	$50			#	push	ax
	$9A $1CF3000Crl		#	call	US_InitRndT
	$58			#	pop	ax
	$9A $05A1000Arl		#	call	FreeUpMemory
	$90 $90 $90 $90 $90 $90	#	(6x nop)

#Don't free the paddle war sprites (in case loading a game fails)
%patch $5A1F $0033w		# default: $002Ew


##################
# Memory Related #
##################

# Fix error in XMS size calculation
%patch $152F3
	$BB $0010w		#	mov	bx, 16
	$F7 $E3			#	mul	bx
	$01 $06 $A1A5w		#	add	..., ax
	$11 $16 $A1A7w		#	adc	..., dx


# Lock text buffers to avoid "PageLayout: Text not headed with ^P" error

# CacheAndLock routine (returns grsegs offset in AX):
%patch $18403
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$57			#	push	di
	$8B $7E $06		#	mov	di, [bp+arg_0]
	$57			#	push	di
	$9A $125A1108rl		#	call	CA_CacheGrChunk
	$58			#	pop	ax
	$B8 $0001w		#	mov	ax, 1
	$50			#	push	ax
	$D1 $E7			#	shl	di, 1
	$81 $C7 $7629w		#	add	di, offset grsegs
	$57			#	push	di
	$9A $15110AD6rl		#	call	MM_SetLock
	$83 $C4 $04		#	add	sp, 4
	$8B $C7			#	mov	ax, di
	$5F			#	pop	di
	$5D			#	pop	bp
	$CB			#	retf
# Note: this overwrites the unused SDL_TimingService code (2 bytes left unused)

# Use CacheAndLock instead of CA_CacheGrChunk to cache the text chunks
%patch $E321 $183B0053rl	# for the ending text


# Make CA_UpLevel flow into CA_ClearMarks so we don't load more	than we need
%patch $13A7C $EB $30


#######################
# Additional Bugfixes #
#######################

# Only remove level entrances for finished levels on world map
# (leave elevator and teleporter coordinates intact):
%patch $5EDB
	$80 $7E $FB $C0		#	cmp	byte ptr [bp-5], 0C0h
	$75 $0D			#	jne	check_barrier
	$90 $90 $90 $90		#	nop nop nop nop

%patch $5EED $90 $80 $7E $FB $D0	# modified barrier check
%patch $5F04 $90 $80 $7E $FB $F0	# modified flag check


# Fix "pole door glitch":
%patch $AC33
	$C7 $45 $10 $0001w	#	mov	[di+objtype.ydir], 1
	$E9 $FF78w		#	jmp	loc_AA2_193


###################
# Fix Engine Bugs #
###################

# Avoid crashing when trying to draw characters that don't exist in the font:
%patch $36EE2 $08C5w

# Make VW_ClearVideo abort if screenseg is NULL:
%patch $1D29D
	$83 $3E $A93Cw $00	#	cmp	screenseg, 0
	$74 $26			#	jz	done
	$B8 $0000w		#	mov	ax, 0
#this patch overwrites some code that effectively sets AX to 0, that's why the
#new code also sets AX to 0 at the end


%end